#!/usr/bin/perl -w

package NastaveniUcetnihoRoku;

BEGIN {
    use src::MymoneyUI;
};


use strict;
use POSIX qw(strftime);

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
#use Gnome2;

use lib "./";
use lib::Table;
use lib::Locks;

my $MyUI;
my %MyMoney;
my $retval;
my $Rok;
my $Locks;

sub run {
    my ($class, $otevrit_rok, %params) = @_;
    
    my $window=$class;
    $MyUI=$window;
    %MyMoney=%params;
    $retval=0;
    $Locks=0;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('g_Rok',"id='".$MyMoney{'RokData'}->get('id')."'")) {
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
    };

    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox22'};
    
    if($otevrit_rok) {
        $Rok=new Table('g_Rok',%MyMoney);
        $Rok->load("id='".$otevrit_rok."'");
    } else {
        $Rok=$MyMoney{'RokData'};
    };

    $window->FORM->{'zacatek_roku'}=Gnome2::DateEdit->new(0,0,0);
    $window->FORM->{'zacatek_roku'}->show;
    $window->FORM->{'table16'}->attach($window->FORM->{'zacatek_roku'}, 2, 3, 1, 2, ['fill'], ['fill', 'expand'], 0, 0);

    $window->FORM->{'konec_roku'}=Gnome2::DateEdit->new(0,0,0);
    $window->FORM->{'konec_roku'}->show;
    $window->FORM->{'table16'}->attach($window->FORM->{'konec_roku'}, 2, 3, 2, 3, ['fill'], ['fill', 'expand'], 0, 0);


    $Rok->WriteToUI($MyUI->FORM);
    $MyUI->on_max_odchylka_dph_toggled;
    $MyUI->on_u_kr_generovat_i_d_toggled;
    $MyUI->on_zaokr_changed;
    $MyUI->on_typ_ucetnictvi_toggled;
    
    #odstranit neimplementovane moduly
    $MyUI->FORM->{'notebook7'}->remove_page(8);
    $MyUI->FORM->{'notebook7'}->remove_page(7);
    $MyUI->FORM->{'notebook7'}->remove_page(6);
    $MyUI->FORM->{'notebook7'}->remove_page(5);
    $MyUI->FORM->{'notebook7'}->remove_page(4);
    $MyUI->FORM->{'notebook7'}->remove_page(3);
    
    $window->TOPLEVEL->set_title('Nastavení účetního roku');
    $MyMoney{'MainCfg'}->window_open("NastaveniUcetnihoRoku",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Gtk2->main;
    return($retval);
};


sub optionmenus_set($$) {
    my($class,$val1,$val2)=@_;
    
    if($MyUI->FORM->{$val1}->get_history eq '0') {
        $MyUI->FORM->{$val2}->set_sensitive(0);
    } else {
        $MyUI->FORM->{$val2}->set_sensitive(1);
    };
};

sub on_zaokr_changed {
    $MyUI->optionmenus_set("u_pokl_zaokr_vyd_dph","u_pokl_zaokr_vyd_dph_m");
    $MyUI->optionmenus_set("u_pokl_zaokr_prij_dph","u_pokl_zaokr_prij_dph_m");
    $MyUI->optionmenus_set("u_pokl_zaokr_vyd_celk","u_pokl_zaokr_vyd_celk_m");
    $MyUI->optionmenus_set("u_pokl_zaokr_prij_celk","u_pokl_zaokr_prij_celk_m");
    $MyUI->optionmenus_set("u_b_zaokr_vyd_dph","u_b_zaokr_vyd_dph_m");
    $MyUI->optionmenus_set("u_b_zaokr_prij_dph","u_b_zaokr_prij_dph_m");
    $MyUI->optionmenus_set("u_b_zaokr_vyd_celk","u_b_zaokr_vyd_celk_m");
    $MyUI->optionmenus_set("u_b_zaokr_prij_celk","u_b_zaokr_prij_celk_m");
    $MyUI->optionmenus_set("u_zp_zaokr_zav_dph","u_zp_zaokr_zav_dph_m");
    $MyUI->optionmenus_set("u_zp_zaokr_poh_dph","u_zp_zaokr_poh_dph_m");
    $MyUI->optionmenus_set("u_zp_zaokr_zav_celk","u_zp_zaokr_zav_celk_m");
    $MyUI->optionmenus_set("u_zp_zaokr_poh_celk","u_zp_zaokr_poh_celk_m");
    $MyUI->optionmenus_set("u_int_zaokr_dph","u_int_zaokr_dph_m");
    $MyUI->optionmenus_set("u_int_zaokr_celk","u_int_zaokr_celk_m");
    $MyUI->optionmenus_set("fak_p_zaokr_dph","fak_p_zaokr_dph_m");
    $MyUI->optionmenus_set("fak_p_zaokr_celk","fak_p_zaokr_celk_m");
    $MyUI->optionmenus_set("fak_v_zaokr_dph","fak_v_zaokr_dph_m");
    $MyUI->optionmenus_set("fak_v_zaokr_celk","fak_v_zaokr_celk_m");
};

sub on_u_kr_generovat_i_d_toggled {
    if($MyUI->FORM->{'u_kr_generovat_i_d'}->get_active) {
        $MyUI->FORM->{'u_kr_prebirat_protiucet'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'u_kr_prebirat_protiucet'}->set_sensitive(0);
    };
};

sub on_typ_ucetnictvi_toggled {
    if($MyUI->FORM->{'typ_ucetnictvi_P'}->get_active) {
        $MyUI->FORM->{'label106'}->set_sensitive(1);
        $MyUI->FORM->{'label107'}->set_sensitive(1);
        $MyUI->FORM->{'label108'}->set_sensitive(1);
        $MyUI->FORM->{'label109'}->set_sensitive(1);
        $MyUI->FORM->{'vbox78'}->set_sensitive(1);
        $MyUI->FORM->{'table22'}->set_sensitive(1);
        $MyUI->FORM->{'vbox82'}->set_sensitive(1);
        $MyUI->FORM->{'hbox202'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'label106'}->set_sensitive(0);
        $MyUI->FORM->{'label107'}->set_sensitive(0);
        $MyUI->FORM->{'label108'}->set_sensitive(0);
        $MyUI->FORM->{'label109'}->set_sensitive(0);
        $MyUI->FORM->{'vbox78'}->set_sensitive(0);
        $MyUI->FORM->{'table22'}->set_sensitive(0);
        $MyUI->FORM->{'vbox82'}->set_sensitive(0);
        $MyUI->FORM->{'hbox202'}->set_sensitive(0);
    };
};

sub on_button_standard_clicked {
    my $RokData=new Table('g_Rok',%MyMoney);
    $RokData->set("ucetni_rok",$MyUI->FORM->{'ucetni_rok'}->get_value);
    $RokData->set("zacatek_roku",$MyUI->FORM->{'ucetni_rok'}->get_value."-"."01-01");
    $RokData->set("konec_roku",$MyUI->FORM->{'ucetni_rok'}->get_value."-"."12-31");
    $RokData->WriteToUI($MyUI->FORM);
    $MyUI->on_max_odchylka_dph_toggled;
    $MyUI->on_u_kr_generovat_i_d_toggled;
    $MyUI->on_zaokr_changed;
    $MyUI->on_typ_ucetnictvi_toggled;
};

sub on_max_odchylka_dph_toggled {
    if($MyUI->FORM->{'max_odchylka_dph_m_A'}->get_active) {
        $MyUI->FORM->{'label146'}->show;
        $MyUI->FORM->{'label147'}->hide;
    } else {
        $MyUI->FORM->{'label146'}->hide;
        $MyUI->FORM->{'label147'}->show;
    };
};

sub on_NastaveniUcetnihoRoku_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("NastaveniUcetnihoRoku",$MyUI->TOPLEVEL);
    $retval=0;
    Gtk2->main_quit;
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("NastaveniUcetnihoRoku",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $Rok->ReadFromUI($MyUI->FORM);
    $Rok->update;
    if($Locks) {
        $Locks->remove_lock;
    };
    
    $MyMoney{'MainCfg'}->window_close("NastaveniUcetnihoRoku",$MyUI->TOPLEVEL);
    $retval=1;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub button_predkontaceP_int {
    my($self,$predkontace)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('predkontace_P',"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>"typ='8'","selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{$predkontace}->get_text])) {
        my $tbl=new Table('r_UcPrKont_P',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$predkontace}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$predkontace}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub button_cleneni {
    my($self,$cleneni)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('cleneni',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{$cleneni}->get_text])) {
        my $tbl=new Table('r_UcClnDPH',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$cleneni}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$cleneni}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_u_kr_kztrata_zav_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kztrata_zav');
};

sub on_button_u_kr_kztrata_poh_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kztrata_poh');
};

sub on_button_u_kr_kztrata_pf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kztrata_pf');
};

sub on_button_u_kr_kztrata_vf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kztrata_vf');
};

sub on_button_u_kr_kzisk_zav_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kzisk_zav');
};

sub on_button_u_kr_kzisk_poh_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kzisk_poh');
};

sub on_button_u_kr_kzisk_pf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kzisk_pf');
};

sub on_button_u_kr_kzisk_vf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kzisk_vf');
};

sub on_button_u_kr_kztrata_odzal_pf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kztrata_odzal_pf');
};

sub on_button_u_kr_kztrata_odzal_vf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kztrata_odzal_vf');
};

sub on_button_u_kr_kzisk_odzal_pf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kzisk_odzal_pf');
};

sub on_button_u_kr_kzisk_odzal_vf_clicked {
    $MyUI->button_predkontaceP_int('u_kr_kzisk_odzal_vf');
};

sub on_button_u_rch_sn_predkontace_clicked {
    $MyUI->button_predkontaceP_int('u_rch_sn_predkontace');
};

sub on_button_u_rch_sn_narok_predkontace_clicked {
    $MyUI->button_predkontaceP_int('u_rch_sn_narok_predkontace');
};

sub on_button_u_rch_bn_predkontace_clicked {
    $MyUI->button_predkontaceP_int('u_rch_bn_predkontace');
};

sub on_button_u_rch_sn_cleneni_clicked {
    $MyUI->button_cleneni('u_rch_sn_cleneni');
};

sub on_button_u_rch_sn_narok_cleneni_clicked {
    $MyUI->button_cleneni('u_rch_sn_narok_cleneni');
};

sub on_button_u_rch_bn_cleneni_clicked {
    $MyUI->button_cleneni('u_rch_bn_cleneni');
};

sub on_button_fak_odp_vf_cleneni_clicked {
    $MyUI->button_cleneni('fak_odp_vf_cleneni');
};

sub on_button_fak_odp_pf_cleneni_clicked {
    $MyUI->button_cleneni('fak_odp_pf_cleneni');
};

sub on_button_fak_odp_vf_predkontace_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $typ='J';
    my $where="typ='P'";
    if($MyUI->FORM->{'typ_ucetnictvi_P'}->get_active) {
        $typ='P';
        $where="typ='0'";
    };
    if($Seznam->run('predkontace_'.$typ,"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>$where,"selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{'fak_odp_vf_predkontace'}->get_text])) {
        my $tbl=new Table('r_UcPrKont_P',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'fak_odp_vf_predkontace'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'fak_odp_vf_predkontace'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_fak_odp_pf_predkontace_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    my $typ='J';
    my $where="typ='V'";
    if($MyUI->FORM->{'typ_ucetnictvi_P'}->get_active) {
        $typ='P';
        $where="typ='1'";
    };
    if($Seznam->run('predkontace_'.$typ,"cfg"=>[%MyMoney],"ok_butt"=>1,"where"=>$where,"selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{'fak_odp_pf_predkontace'}->get_text])) {
        my $tbl=new Table('r_UcPrKont_P',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'fak_odp_pf_predkontace'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'fak_odp_pf_predkontace'}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub button_uctu {
    my($self,$ucet)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('uctova_osnova',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"ucet","selected_rows"=>[$MyUI->FORM->{$ucet}->get_text])) {
        my $tbl=new Table('r_UcOsnova',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$ucet}->set_text($tbl->get('ucet'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$ucet}->set_text('000000');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_button_u_uzav_pur_clicked {
    $MyUI->button_uctu('u_uzav_pur');
};

sub on_button_u_uzav_kur_clicked {
    $MyUI->button_uctu('u_uzav_kur');
};

sub on_button_u_uzav_uzz_clicked {
    $MyUI->button_uctu('u_uzav_uzz');
};

sub on_button_u_uzav_uhv_clicked {
    $MyUI->button_uctu('u_uzav_uhv');
};

1;
