#!/usr/bin/perl -w

package NovaAgenda;

BEGIN {
    use src::MymoneyUI;
};


use strict;

use POSIX qw(strftime);

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gtk2::SimpleList;
use Gnome2;

use lib "./";
use lib::NastaveniAgendy;
use lib::Dialog;

my $MyUI;
my $retval;
my $druidwin;
my %MyMoney=();

my $vytvorena_agenda=0;
my $vytvoreny_rok=0;

sub run {
    my ($class, %params) = @_;
    
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$window;
    $retval=0;
    
    my ($druid,$w)= Gnome2::Druid->new_with_window("Průvodce přidáním nové agendy", undef, 0);
    $w->set_modal(1);
    $w->set_position('center');
    $w->signal_connect('unrealize' => "on_window_unrealize");
    $druidwin=$w;
    
    $druid->finish->set_label ("_Dokončit");
    $druid->finish->signal_connect (clicked => "on_button_finish_clicked");
    $druid->cancel->signal_connect (clicked => "on_button_cancel_clicked");
    
    
    my $druid_page = Gnome2::DruidPageEdge->new_with_vals ('start', 0,
						   "Průvodce přidánim nové agendy",
						   "Tento průvodce vám umožní rychle a jednoduše přidat novou agendu.\n\nPrůvodce spustíte klepnutím na tlačítko Vpřed.\n",
						   undef,
						   undef,
						   undef);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 1/6 - Popis agendy a adresa", undef, undef);
    $window->FORM->{'vbox_page1'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 2/6 - Telefonní spojení a identifikace firmy", undef, undef);
    $window->FORM->{'vbox_page2'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 3/6 - Výběr účetního roku", undef, undef);
    $window->FORM->{'vbox_page3'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 4/6 - Naplnění agendy účetními daty", undef, undef);
    $window->FORM->{'vbox_page4'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 5/6 - Připravené seznamy", undef, undef);
    $window->FORM->{'notebook_page5'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageEdge->new_with_vals ('finish', 0,
						   "Strana 6/6 - Závěr",
						   "Průvodce přidáním nové agendy je u konce.\n\nNyní klepnutím na tlačítko Dokončit vytvoříte novou agendu a můžete přejít k jejímu nastavení a k nastavení parametrů účetního roku.\n",
						   undef,
						   undef,
						   undef);
    $druid->append_page ($druid_page);

    # inicializace
    $window->FORM->{'spinbutton_ucetni_rok'}->set_value(strftime("%Y",localtime));
    $window->FORM->{'radiobutton_plnit_z_pripravenych_seznamu'}->set_active(1);
    my $slist = Gtk2::SimpleList->new('selected'=>'bool','name'=>'text');
    @{$slist->{data}} = (
          [1,'Časově rozlišitelné údaje mezd'],
          [1,'Seznam pracovních poměrů'],
          [1,'Číselné řady'],
          [1,'Předkontace'],
          [1,'Účtovou osnovu'],
          [1,'Členění DPH'],
          [1,'Seznam XML přenosů'],
          [1,'Uživatelské tiskové sestavy z úč. denníku']
    );
    $slist->set_headers_visible(0);
    $window->FORM->{'scrolledwindow1'}->add($slist);

    $window->FORM->{'optionmenu_agenda'}->set_history(0);
    $window->FORM->{'optionmenu_rok'}->set_history(0);
    my $slist2 = Gtk2::SimpleList->new('selected'=>'bool','name'=>'text');
    @{$slist2->{data}} = (
          [0,'Konfigurace účetního roku'],
          [1,'Časově rozlišitelné údaje mezd (v připravených seznamech)'],
          [1,'Konfigurace uživatelského nastavení'],
          [1,'Seznam středisek'],
          [1,'Seznam zakázek'],
          [1,'Seznam činností'],
          [1,'Seznam typů účetních položek'],
          [1,'Seznam typů účetních dokladů'],
          [1,'Seznam typů faktur'],
          [1,'Seznam typů skladových dokladů'],
          [1,'Seznam typů objednávek'],
          [1,'Seznam pracovních poměrů (v připravených seznamech)'],
          [1,'Číselné řady (v připravených seznamech)'],
          [1,'Předkontace (v připravených seznamech)'],
          [1,'Účtovou osnovu (v připravených seznamech)'],
          [1,'Členění DPH (v připravených seznamech)'],
	  [1,'Definice výkazu Cache flow'],
          [1,'Seznam XML přenosů (v připravených seznamech)'],
          [1,'Uživatelské tiskové sestavy z úč. denníku (v připravených seznamech)']
    );
    $slist2->set_headers_visible(0);
    $window->FORM->{'scrolledwindow2'}->add($slist2);
    
    $MyMoney{'MainCfg'}->window_open("NovaAgenda",$w);
    $w->show_all;

    #$window->TOPLEVEL->show;
    Gtk2->main;
    return($retval);
};

sub on_radiobutton_plnit_z_pripravenych_seznamu_toggled {
    $MyUI->FORM->{'notebook_page5'}->set_current_page(0);
};

sub on_radiobutton_plnit_z_agendy_toggled {
    $MyUI->FORM->{'notebook_page5'}->set_current_page(1);
};

sub on_radiobutton_neplnit_toggled {
    $MyUI->FORM->{'notebook_page5'}->set_current_page(2);
};

sub on_radiobutton_typ_subjektu_toggled {
    if($MyUI->FORM->{'typ_subjektu_S'}->get_active) {
        $MyUI->FORM->{'frame86'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'frame86'}->set_sensitive(0);
    };
};

sub on_button_finish_clicked {
    my $AgendaData=new Table('g_Agenda',%MyMoney);


    my $rok=$MyUI->FORM->{'spinbutton_ucetni_rok'}->get_value;
    if(! -d "./data/rok/".$rok) {
	my @roky=`ls -1 ./data/rok/`;
	my $nejvyssi_rok=0;
	foreach $_ (@roky) {
	    chomp;
	    $_=int($_);
	    if(-d "./data/rok/".$_) {
		if($_>$nejvyssi_rok) {
		    $nejvyssi_rok=$_;
		};
	    };
	};
	my $Dialog=new Dialog;
	if($nejvyssi_rok) {
		if(!$Dialog->show('text'=>"Nebyly nalezeny připravené konfigurace pro rok ".$rok.".\n\nChcete načíst konfigurace z nejvyššího známeho roku ".$nejvyssi_rok."?",'type'=>'question')) {
		    return;
		};
		$rok=$nejvyssi_rok;
	} else {
	    $Dialog->show('text'=>"Nebyly nalezeny připravené konfigurace!",'type'=>'error');
	    return;
	};
    };
    $MyMoney{'MainCfg'}->window_close("NovaAgenda",$druidwin);
    $druidwin->hide;

    $AgendaData->ReadFromUI($MyUI->FORM);

    $AgendaData->set("ob_nazev" => $AgendaData->get('nazev'));
    $AgendaData->set("ob_ulice" => $AgendaData->get('ulice'));
    $AgendaData->set("ob_mesto" => $AgendaData->get('mesto'));
    $AgendaData->set("ob_psc" => $AgendaData->get('psc'));
    $AgendaData->set("ob_stat" => $AgendaData->get('stat'));


    $AgendaData->save;
    #$AgendaData->createdb;

    my $NastaveniAgendy=new NastaveniAgendy;
    $NastaveniAgendy->run($AgendaData->get('id'),%MyMoney);


    my $RokData=new Table('g_Rok',%MyMoney);
    $RokData->read_defaults($rok);
    if($MyUI->FORM->{'radiobutton_plnit_z_pripravenych_seznamu'}->get_active) {
	$RokData->read_seznamy_defaults($rok);
    };
    $RokData->set("agenda_id",$AgendaData->get("id"));
    $RokData->set("ucetni_rok",$MyUI->FORM->{'spinbutton_ucetni_rok'}->get_value);
    $RokData->set("zacatek_roku",$MyUI->FORM->{'spinbutton_ucetni_rok'}->get_value."-"."01-01");
    $RokData->set("konec_roku",$MyUI->FORM->{'spinbutton_ucetni_rok'}->get_value."-"."12-31");

    if($MyUI->FORM->{'typ_ucetnictvi_P'}->get_active) {
	$RokData->set("typ_ucetnictvi","P");
    } else {
	$RokData->set("typ_ucetnictvi","J");
    };

    $RokData->save;
    #$RokData->createdb;

    my $NastaveniUcetnihoRoku=new NastaveniUcetnihoRoku;
    $NastaveniUcetnihoRoku->run($RokData->get('id'),%MyMoney);
    
    $vytvorena_agenda=$AgendaData->get('id');
    $vytvoreny_rok=$RokData->get('id');

    $retval=1;
    
    Gtk2->main_quit;
    
};

sub on_button_cancel_clicked {
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("NovaAgenda",$druidwin);
    $druidwin->hide;
    Gtk2->main_quit;
};

sub on_window_unrealize {
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("NovaAgenda",$druidwin);
    Gtk2->main_quit;
};

sub get_created {
    return('agenda'=>$vytvorena_agenda,'rok'=>$vytvoreny_rok);
};

1;
