#!/usr/bin/perl -w

package NovyUcetniRok;

BEGIN {
    use src::MymoneyUI;
};


use strict;

use POSIX qw(strftime);

#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gtk2::SimpleList;
use Gnome2;

use lib "./";
use lib::Table;
use lib::NastaveniUcetnihoRoku;

my $MyUI;
my $retval;
my $druidwin;
my %MyMoney=();

my @agenda_id=();
my @rok_id=();
my $zvolena_agenda=0;

sub run {
    my ($class, $agenda, %params) = @_;
    
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$window;
    $retval=0;
    $zvolena_agenda=$agenda;
    
    my ($druid,$w)= Gnome2::Druid->new_with_window("Průvodce přidáním nového účetního roku", undef, 0);
    $w->set_modal(1);
    $w->set_position('center');
    $w->signal_connect('unrealize' => "on_window_unrealize");
    $druidwin=$w;
    
    $druid->finish->set_label ("_Dokončit");
    $druid->finish->signal_connect (clicked => "on_button_finish_clicked");
    $druid->cancel->signal_connect (clicked => "on_button_cancel_clicked");
    
    
    my $Agenda=new Table('g_Agenda',%MyMoney);
    $Agenda->load("id='".$zvolena_agenda."'");
    
    my $druid_page = Gnome2::DruidPageEdge->new_with_vals ('start', 0,
						   "Průvodce přidáním nového účetního roku",
						   "Tento průvodce vám umožní rychle a jednoduše přidat nový\núčetní rok v agendě:\n\n".$Agenda->get('ob_nazev')."\n\n\nPrůvodce spustíte klepnutím na tlačítko Vpřed.\n",
						   undef,
						   undef,
						   undef);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 1/5", undef, undef);
    $window->FORM->{'vbox_page1'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 2/5", undef, undef);
    $window->FORM->{'vbox_page2'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 3/5", undef, undef);
    $window->FORM->{'vbox_page3'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);

    $druid_page = Gnome2::DruidPageStandard->new_with_vals ("Strana 4/5", undef, undef);
    $window->FORM->{'vbox_page4'}->reparent($druid_page->vbox);
    $druid->append_page ($druid_page);


    $druid_page = Gnome2::DruidPageEdge->new_with_vals ('finish', 0,
						   "Strana 5/5 - Závěr",
						   "Průvodce přidáním nového účetního roku je u konce.\n\nNyní klepnutím na tlačítko Dokončit vytvoříte nový účetní rok.\n",
						   undef,
						   undef,
						   undef);
    $druid->append_page ($druid_page);

    # inicializace
    $window->FORM->{'ucetni_rok'}->set_value(strftime("%Y",localtime));
    $window->FORM->{'radiobutton_konfigurace_roku_Y'}->set_active(1);
    my $slist = Gtk2::SimpleList->new('selected'=>'bool','name'=>'text');
    @{$slist->{data}} = (
          [0,'Konfigurace účetního roku'],
          [1,'Konfigurace uživatelského nastavení'],
          [1,'Seznam středisek'],
          [1,'Seznam zakázek'],
          [1,'Seznam činností'],
          [1,'Seznam typů účetních položek'],
          [1,'Seznam typů účetních dokladů'],
          [1,'Seznam typů faktur'],
          [1,'Seznam typů skladových dokladů'],
          [1,'Číselné řady (v připravených seznamech)'],
          [1,'Předkontace (v připravených seznamech)'],
          [1,'Účtovou osnovu (v připravených seznamech)'],
          [1,'Členění DPH (v připravených seznamech)'],
	  [1,'Definice výkazu Cache flow']
    );
    $slist->set_headers_visible(0);
    $window->FORM->{'slist_seznamy'}=$slist;
    $window->FORM->{'scrolledwindow12'}->add($window->FORM->{'slist_seznamy'});


    $window->FORM->{'optionmenu_agenda'}->remove_menu;
    my $DatabazeA=new Databaze(%MyMoney);
    my $DatabazeR=new Databaze(%MyMoney);
    $DatabazeA->Read('g_Agenda',"",('id','ob_nazev'));
    @agenda_id=();
    my @agenda_nazev=();
    for(my $i=0;$i<$DatabazeA->numrows;$i++) {
        #$DatabazeA->dataseek($i);
        my %row=$DatabazeA->fetchhash;
	$DatabazeR->Read('g_Rok',"agenda_id='".$row{'id'}."'",('id','ucetni_rok'));
	if($DatabazeR->numrows) {
            push(@agenda_id,$row{'id'});
	    push(@agenda_nazev,$row{'ob_nazev'});
	};
    };
    if(@agenda_nazev) {
	my $menu=new Gtk2::Menu;
	$window->FORM->{'optionmenu_agenda'}->set_menu($menu);
	foreach $_ (@agenda_nazev) {
	    my $menuitem=new_with_mnemonic Gtk2::MenuItem(_($_));
	    $menu->append($menuitem);
	};
	$menu->show_all;
    };
    $window->FORM->{'optionmenu_agenda'}->set_history(0);
    $MyUI->FORM->{'radiobutton_zpusob3'}->set_active(1);
    $MyUI->on_radiobutton_zpusob_toggled;
    $MyMoney{'MainCfg'}->window_open("NovyUcetniRok",$druidwin);
    $w->show_all;

    #$window->TOPLEVEL->show;
    Gtk2->main;
    return($retval);
};

sub on_button_finish_clicked {
    my $rok=$MyUI->FORM->{'ucetni_rok'}->get_value;
    if(! -d "./data/rok/".$rok) {
	my @roky=`ls -1 ./data/rok/`;
	my $nejvyssi_rok=0;
	foreach $_ (@roky) {
	    chomp;
	    $_=int($_);
	    if(-d "./data/rok/".$_) {
		if($_>$nejvyssi_rok) {
		    $nejvyssi_rok=$_;
		};
	    };
	};
	my $Dialog=new Dialog;
	if($nejvyssi_rok) {
		if(!$Dialog->show('text'=>"Nebyly nalezeny připravené konfigurace pro rok ".$rok.".\n\nChcete načíst konfigurace z nejvyššího známeho roku ".$nejvyssi_rok."?",'type'=>'question')) {
		    return;
		};
		$rok=$nejvyssi_rok;
	} else {
	    $Dialog->show('text'=>"Nebyly nalezeny připravené konfigurace!",'type'=>'error');
	    return;
	};
    };
    $MyMoney{'MainCfg'}->window_close("NovyUcetniRok",$druidwin);
    $druidwin->hide;
    my $RokData=new Table('g_Rok',%MyMoney);
    $RokData->read_defaults($rok);
    if($MyUI->FORM->{'radiobutton_zpusob3'}->get_active) {
	$RokData->read_seznamy_defaults($rok);
    };
    $RokData->set("agenda_id",$zvolena_agenda);
    $RokData->set("ucetni_rok",$MyUI->FORM->{'ucetni_rok'}->get_value);
    $RokData->set("zacatek_roku",$MyUI->FORM->{'ucetni_rok'}->get_value."-"."01-01");
    $RokData->set("konec_roku",$MyUI->FORM->{'ucetni_rok'}->get_value."-"."12-31");
    if($MyUI->FORM->{'typ_ucetnictvi_P'}->get_active) {
	$RokData->set("typ_ucetnictvi","P");
    } else {
	$RokData->set("typ_ucetnictvi","J");
    };
    $RokData->save;
    #$RokData->createdb;

    if($MyUI->FORM->{'radiobutton_konfigurace_roku_Y'}->get_active) {
        my $NastaveniUcetnihoRoku=new NastaveniUcetnihoRoku;
        $NastaveniUcetnihoRoku->run($RokData->get('id'),%MyMoney);
    };

    $retval=$RokData->get('id');
    
    Gtk2->main_quit;
    
};

sub on_radiobutton_zpusob_toggled {
    
    #
    # kopie z predchozich let
    #
    if($MyUI->FORM->{'radiobutton_zpusob1'}->get_active) {
	my $i=0;
	$MyUI->FORM->{'optionmenu_rok'}->remove_menu;
	my $DatabazeR=new Databaze(%MyMoney);
	$DatabazeR->Read('g_Rok',"agenda_id='".$zvolena_agenda."'",('id','ucetni_rok'));
	@rok_id=();
	my @rok_nazev=();
	for($i=0;$i<$DatabazeR->numrows;$i++) {
	    #$DatabazeR->dataseek($i);
	    my %row=$DatabazeR->fetchhash;
	    push(@rok_id,$row{'id'});
	    push(@rok_nazev,$row{'ucetni_rok'});
	};
	if($i) {
	    $i--;
	};
	if(@rok_nazev) {
	    my $menu=new Gtk2::Menu;
	    $MyUI->FORM->{'optionmenu_rok'}->set_menu($menu);
	    foreach $_ (@rok_nazev) {
		my $menuitem=new_with_mnemonic Gtk2::MenuItem(_($_));
		$menu->append($menuitem);
	    };
	    $menu->show_all;
	};
	$MyUI->FORM->{'optionmenu_rok'}->set_history($i);
	
	my @slist_data=();
	my $j=0;
	foreach $_ (@{$MyUI->FORM->{'slist_seznamy'}->{data}}) {
	    my @row=@{$_};
	    if($j!=0) {
		$row[0]=1;
	    } else {
		$row[0]=0;
	    };
	    $j++;   
	    push(@slist_data,[@row]);
	};
	@{$MyUI->FORM->{'slist_seznamy'}->{data}}=@slist_data;
    };
    
    #
    # kopie z jine agendy
    #
    if($MyUI->FORM->{'radiobutton_zpusob2'}->get_active) {
	$MyUI->FORM->{'hbox260'}->set_sensitive(1);
	$MyUI->on_optionmenu_agenda_changed;

	my @slist_data=();
	my $j=0;
	foreach $_ (@{$MyUI->FORM->{'slist_seznamy'}->{data}}) {
	    my @row=@{$_};
	    if($j!=0) {
		$row[0]=1;
	    } else {
		$row[0]=0;
	    };
	    $j++;   
	    push(@slist_data,[@row]);
	};
	@{$MyUI->FORM->{'slist_seznamy'}->{data}}=@slist_data;
    } else {
	$MyUI->FORM->{'hbox260'}->set_sensitive(0);
    };
    
    if(($MyUI->FORM->{'radiobutton_zpusob3'}->get_active) || ($MyUI->FORM->{'radiobutton_zpusob4'}->get_active)) {
	my $i=0;
	$MyUI->FORM->{'optionmenu_rok'}->remove_menu;

	my @pripravene_roky=`/bin/ls -1 ./data/rok/`;
	@rok_id=();
	my @rok_nazev=();
	foreach $_ (@pripravene_roky) {
	    chomp;
	    if( -d "./data/rok/".$_) {
		push(@rok_id,$_);
		push(@rok_nazev,$_);
		$i++;
	    };
	};
	if($i) {
	    $i--;
	};
	if(@rok_nazev) {
	    my $menu=new Gtk2::Menu;
	    $MyUI->FORM->{'optionmenu_rok'}->set_menu($menu);
	    foreach $_ (@rok_nazev) {
		my $menuitem=new_with_mnemonic Gtk2::MenuItem(_($_));
		$menu->append($menuitem);
	    };
	    $menu->show_all;
	};
	$MyUI->FORM->{'optionmenu_rok'}->set_history($i);

	#
	# vytvorit z pripravenych seznamu
	#
	if($MyUI->FORM->{'radiobutton_zpusob3'}->get_active) {
	    my @slist_data=();
	    my $j=0;
	    foreach $_ (@{$MyUI->FORM->{'slist_seznamy'}->{data}}) {
		my @row=@{$_};
		if($j!=0) {
		    $row[0]=1;
		} else {
		    $row[0]=0;
		};
		$j++;   
		push(@slist_data,[@row]);
	    };
	    @{$MyUI->FORM->{'slist_seznamy'}->{data}}=@slist_data;
	};
	
	#
	# vytvorit prazdnou databazi roku a nabidnout pripravene seznamy
	#
	if($MyUI->FORM->{'radiobutton_zpusob4'}->get_active) {
	    my @slist_data=();
	    foreach $_ (@{$MyUI->FORM->{'slist_seznamy'}->{data}}) {
		my @row=@{$_};
		$row[0]=0;
		push(@slist_data,[@row]);
	    };
	    @{$MyUI->FORM->{'slist_seznamy'}->{data}}=@slist_data;
	};
    };
};

sub on_optionmenu_agenda_changed {
	my $i=0;
	$MyUI->FORM->{'optionmenu_rok'}->remove_menu;
	my $DatabazeR=new Databaze(%MyMoney);
	$DatabazeR->Read('g_Rok',"agenda_id='".$agenda_id[$MyUI->FORM->{'optionmenu_agenda'}->get_history]."'",('id','ucetni_rok'));
	@rok_id=();
	my @rok_nazev=();
	for($i=0;$i<$DatabazeR->numrows;$i++) {
	    #$DatabazeR->dataseek($i);
	    my %row=$DatabazeR->fetchhash;
	    push(@rok_id,$row{'id'});
	    push(@rok_nazev,$row{'ucetni_rok'});
	};
	if($i) {
	    $i--;
	};
	if(@rok_nazev) {
	    my $menu=new Gtk2::Menu;
	    $MyUI->FORM->{'optionmenu_rok'}->set_menu($menu);
	    foreach $_ (@rok_nazev) {
		my $menuitem=new_with_mnemonic Gtk2::MenuItem(_($_));
		$menu->append($menuitem);
	    };
	    $menu->show_all;
	};
	$MyUI->FORM->{'optionmenu_rok'}->set_history($i);
};

sub on_button_cancel_clicked {
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("NovyUcetniRok",$druidwin);
    $druidwin->hide;
    Gtk2->main_quit;
};

sub on_window_unrealize {
    $retval=0;
    $MyMoney{'MainCfg'}->window_close("NovyUcetniRok",$druidwin);
    Gtk2->main_quit;
};


1;
