#!/usr/bin/perl -w

package PredkontaceJ;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;

use lib "./";
use lib::Dialog;
use lib::Locks;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my $retcode="";
my $Predkontace;
my $Locks;

sub upravit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    my $dissable_ok=0;
    $Locks=0;
    if($where) {
        $Locks=new Locks(%MyMoney);
        if(!$Locks->create_lock('r_UcPrKont_J',$where)) {
            $dissable_ok=1;
        };
    };
    return($self->run($dissable_ok, $where,0,%params));
};

sub kopirovat {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0, $where,1,%params));
};

sub pridat {
    my ($self, %params) = @_;
    %MyMoney=%params;
    $Locks=0;
    return($self->run(0,'',0,%params));
};

sub odstranit {
    my ($self, $where, %params) = @_;
    %MyMoney=%params;
    $Locks=new Locks(%MyMoney);
    if(!$Locks->create_lock('r_UcPrKont_J',$where,1)) {
        return(0);
    };
    my $Databaze=new Databaze(%MyMoney);
    if(!$Databaze->Remove("r".$MyMoney{'RokData'}->get('id')."_UcPrKont_J",$where)) {
        $Locks->remove_lock;
        return(0);
    };
    $Locks->remove_lock;
    return(1);
};

sub run {
    my ($class, $dissable_ok, $where, $kopie, %params) = @_;
    $retcode=0;
    %MyMoney=%params;
    my $window=$class;
    $MyUI=$class;
    $Predkontace=new Table('r_UcPrKont_J',%MyMoney);
    if(!$kopie) {
        $class->{'where'}=$where;
    } else {
        $class->{'where'}="";
    };
    if($dissable_ok) {
        $window->FORM->{'button_ok'}->set_sensitive(0);
    };

    if($where) {
        if(!$Predkontace->load($where,1)) {
            my $Dialog=new Dialog;
            $Dialog->show("text"=>"Záznam nelze načíst!\nZřejme byl změněn jiným uživatelem.","type"=>"error");
            if($Locks) {
                $Locks->remove_lock;
            };
            return(0);
        };
    };
    $Predkontace->WriteToUI($window->FORM);
    
    $MyUI=$window;
    $window->TOPLEVEL->set_title('Předkontace');
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'hbox325'};
    $MyMoney{'MainCfg'}->window_open("PredkontaceJ",$MyUI->TOPLEVEL);
    $window->TOPLEVEL->show;
    Gtk2->main;
    return($retcode);
};

sub on_button_close_clicked {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("PredkontaceJ",$MyUI->TOPLEVEL);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_Predkontace_unrealize {
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("PredkontaceJ",$MyUI->TOPLEVEL);
    Gtk2->main_quit;
};

sub on_button_ok_clicked {   
    $Predkontace->ReadFromUI($MyUI->FORM);
    if(!$Predkontace->get('zkrat')) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Zkratka nemůže být prázdná!","type"=>"error");
            return;        
    };
    if($MyUI->{'where'}) {
        if(!$Predkontace->update) {
            return;
        };
    } else {
        if(!$Predkontace->save(1)) {
            my $Dialog=new Dialog(%MyMoney);
            $Dialog->show("text"=>"Záznam nelze uložit!\nZřejmě ukládáte duplicitní klíč.","type"=>"error");
            return;
        };
    };
    if($Locks) {
        $Locks->remove_lock;
    };
    $MyMoney{'MainCfg'}->window_close("PredkontaceJ",$MyUI->TOPLEVEL);
    $retcode=$Predkontace;
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub button_ucpohybu {
    my ($self,$pohyb)=@_;
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $typ='V';
    if($MyUI->FORM->{'typ_P'}->get_active) {
        $typ='P';
    };
    my $Seznam=new Seznam;
    if($Seznam->run('ucetni_pohyby_'.$typ,"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{$pohyb}->get_text])) {
        my $tbl=new Table('r_UcPohyby',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{$pohyb}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{$pohyb}->set_text('');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};
sub on_button_pohzak_clicked {
    $MyUI->button_ucpohybu('pohzak');
};

sub on_button_pohdzs_clicked {
    $MyUI->button_ucpohybu('pohdzs');
};

sub on_button_pohdss_clicked {
    $MyUI->button_ucpohybu('pohdss');
};

sub on_button_cleneni_clicked {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Seznam=new Seznam;
    if($Seznam->run('cleneni',"cfg"=>[%MyMoney],"ok_butt"=>1,"selected_rows_by"=>"zkrat","selected_rows"=>[$MyUI->FORM->{'cleneni'}->get_text])) {
        my $tbl=new Table('r_UcClnDPH',%MyMoney);
        if($Seznam->selected_where) {
            if($tbl->load($Seznam->selected_where,1)) {
                $MyUI->FORM->{'cleneni'}->set_text($tbl->get('zkrat'));
            } else {
                my $Dialog=new Dialog;
                $Dialog->show("text"=>"Zaznam nelze nacist!\nZrejme byl zmenen jinym uzivatelem.","type"=>"error");
                $MyUI->{'TOPFORM'}->set_sensitive(1);
                return;
            };
        } else {
            $MyUI->FORM->{'cleneni'}->set_text('');
        }
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

1;
